<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Relations\BelongsTo;
use Illuminate\Database\Eloquent\Relations\HasMany;

class Component extends UuidModel
{
    protected $fillable = [
        'name',
        'type_id',
        'page_id',
        'parent_id',
        'status',
        'order',
    ];

    public function type() : BelongsTo
    {
        return $this->belongsTo(ComponentType::class, 'type_id');
    }

    public function children () : HasMany
    {
        return $this->hasMany(Component::class, 'parent_id');
    }

    public function parameters(): HasMany
    {
        return $this->hasMany(Parameter::class);
    }
}
