<?php

namespace App\Models;

use Faker\Provider\Uuid;
use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;
use Illuminate\Database\Eloquent\Relations\HasMany;

class Group extends UuidModel
{
    use HasFactory;

    protected $fillable = [
        'id',
        'name',
        'slug'
    ];

    public function pages(): HasMany
    {
        return $this->hasMany(Page::class);
    }
}
