<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Relations\BelongsTo;
use Illuminate\Database\Eloquent\Relations\HasMany;

class Page extends UuidModel
{
    protected $fillable = [
        'id',
        'title',
        'slug',
        'status',
        'parent_id',
        'group_id'
    ];

    public function group(): BelongsTo
    {
        return $this->belongsTo(Group::class);
    }
    public function children(): HasMany
    {
        return $this->hasMany(Page::class, 'parent_id', 'id');
    }
}
