<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Relations\BelongsTo;
use Illuminate\Database\Eloquent\Relations\HasMany;

class Section extends UuidModel
{
    protected $fillable = [
        'name',
        'page_id',
        'status',
        'order',
    ];

    public function page() : BelongsTo
    {
        return $this->belongsTo(Page::class);
    }

    public function rows() : HasMany
    {
        return $this->hasMany(Row::class);
    }
}
