<?php

use Illuminate\Database\Migrations\Migration;
use Illuminate\Database\Schema\Blueprint;
use Illuminate\Support\Facades\Schema;

return new class extends Migration
{
    /**
     * Run the migrations.
     */
    public function up(): void
    {
        Schema::create('components', function (Blueprint $table) {
            $table->uuid('id')->primary();
            $table->string('name')->nullable();
            $table->foreignUuid('page_id')->nullable()->constrained('pages')->onDelete('cascade');
            $table->foreignUuid('type_id')->constrained('component_types')->onDelete('cascade');
            $table->foreignUuid('parent_id')->nullable()->constrained('components')->onDelete('set null');
            $table->integer('order')->nullable();
            $table->enum('status', ['draft', 'published'])->default('draft');

            $table->timestamps();
        });
    }

    /**
     * Reverse the migrations.
     */
    public function down(): void
    {
        Schema::dropIfExists('components');
    }
};
